
import java.util.ArrayList;
import java.util.List;
import java.util.Random;

public class EliminaIsole {
    public static final int larghezza = 35;
    public static final int altezza = 30;

    public static void main(String[] args) {
        boolean[][] mappa = new boolean[altezza][larghezza];

        Random random = new Random();
        for (int x = 0; x < altezza; x++) {
            for (int y = 0; y < larghezza; y++) {
                mappa[x][y] = random.nextBoolean();
            }
        }
        System.out.println("Originale:");
        stampaMappa(mappa);

        for (int x = 0; x < altezza; x++) {
            for (int y = 0; y < larghezza; y++) {
                mappa[x][y] = isIsola(x, y, mappa, new ArrayList<>());
            }
        }

        System.out.println("Nuova:");
        stampaMappa(mappa);
    }

    public static void stampaMappa(boolean[][] mappa) {
        if (mappa.length < 1) {
            return;
        }

        System.out.println("--".repeat(larghezza + 1));
        for (int x = 0; x < altezza; x++) {
            System.out.print("|");
            for (int y = 0; y < larghezza; y++) {
                System.out.print(mappa[x][y] ? "##" : "  ");
            }
            System.out.print("|\n");
        }
        System.out.println("--".repeat(larghezza + 1));
    }

    public static boolean isIsola(int x, int y, boolean[][] mappa, List<Coordinate> visitati) {
        if (!mappa[x][y]) {
            return false;
        }
        if (visitati.contains(new Coordinate(x, y))) {
            return false;
        }
        visitati.add(new Coordinate(x, y));
        if (x == 0 || x == altezza - 1 || y == 0 || y == larghezza - 1) {
            return true;
        }

        return isIsola(x + 1, y, mappa, visitati)
                || isIsola(x, y + 1, mappa, visitati)
                || isIsola(x - 1, y, mappa, visitati)
                || isIsola(x, y - 1, mappa, visitati);
    }

    public static class Coordinate {

        public int x;
        public int y;

        public Coordinate(int x, int y) {
            this.x = x;
            this.y = y;
        }

        @Override
        public boolean equals(Object other) {
            if (!(other instanceof Coordinate coordinate)) {
                return false;
            }
            return x == coordinate.x && y == coordinate.y;
        }
    }
}
